import uuid
from enum import Enum
import datetime

class JobSpec(object):
    """
    High-level job description generated by scheduler. Does not contain specific 
    path information
    """
    def __init__(self,pickup,drop_off,pickup_attempts,drop_off_attempts,payload_id,job_id=None):
        self.pickup = pickup
        self.drop_off = drop_off
        self.pickup_attempts = pickup_attempts
        self.drop_off_attempts = drop_off_attempts
        self.payload_id = payload_id
        if job_id == None:
            self.job_id = uuid.uuid4() #TODO think about how we want to handle ids. Might want to just let a db handle it if we go that route
        else:
            self.job_id = job_id

class Job(JobSpec):
    """
    Extended job information that includes path info. Generated by fleet manager 
    and executed by drone manager. The flight manager will store this flight 
    path until it is fully executed.
    """
    def __init__(self,\
                 job_spec,\
                 drone_id,\
                 take_off_path,\
                 take_off_pose,\
                 go_to_pickup_path,\
                 go_to_pickup_path_db_index,\
                 go_to_pickup_pose,\
                 pick_up_path,\
                 pick_up_pose,\
                 go_to_drop_off_path,\
                 go_to_drop_off_path_db_index,\
                 go_to_drop_off_pose,\
                 drop_off_path,\
                 drop_off_pose,\
                 go_to_dock_path,\
                 go_to_dock_path_db_index,\
                 go_to_dock_pose,\
                 dock_landing_path,\
                 dock_landing_pose):

        JobSpec.__init__(self,\
                        job_spec.pickup,\
                        job_spec.drop_off,\
                        job_spec.pickup_attempts,\
                        job_spec.drop_off_attempts,\
                        job_spec.payload_id,\
                        job_spec.job_id)
        #Store path info from flight traffic controller
        self.drone_id = drone_id
        self.take_off_path = take_off_path
        self.take_off_pose = take_off_pose
        self.go_to_pickup_path = go_to_pickup_path
        self.go_to_pickup_path_db_index = go_to_pickup_path_db_index
        self.go_to_pickup_pose = go_to_pickup_pose
        self.pick_up_path = pick_up_path
        self.pick_up_pose = pick_up_pose
        self.go_to_drop_off_path = go_to_drop_off_path
        self.go_to_drop_off_path_db_index = go_to_drop_off_path_db_index
        self.go_to_drop_off_pose = go_to_drop_off_pose
        self.drop_off_path = drop_off_path
        self.drop_off_pose = drop_off_pose
        self.go_to_dock_path = go_to_dock_path
        self.go_to_dock_path_db_index = go_to_dock_path_db_index
        self.go_to_dock_pose = go_to_dock_pose
        self.dock_landing_path = dock_landing_path
        self.dock_landing_pose = dock_landing_pose

class DroneStatus(object):
    """
    Drone status maintained by Drone Manager. More detail-oriented about 
    executing the current job than the drone status Fleet Manager maintains.
    """
    def __init__(self):
        self.state = 0
        self.path_array = []
        self.path_index = 0
        self.loaded = False
        self.position = None
        self.last_update_timestamp = datetime.datetime.now()

#TODO Consider removing/refactoring
class BatteryStatus(object):
    """
    Timestamped record of battery level. This is returned by the heartbeat 
    GetBattery method in Drone Manager and exposed to Fleet Manager.
    Might consider removing in favor of the two properties by themselves. 
    Not sure I see the value considering there is a separate timestamp that is 
    more inclusively updated.
    """
    def __init__(self):
        self.percent = -1
        self.timestamp = datetime.datetime.now()

class StateChangeRequest(object):
    """
    For internal bookkeeping in drone manager.
    """
    def __init__(self,state,path,pose):
        self.state = state
        self.path = path
        self.pose = pose


#Working on deprecating this for anything but high-level pretty display purposes.
class DroneState(Enum):
    """
    Pretty display version of acl_msgs/msg/HexSMState.msg
    """
    START_UP           = 0
    DOCKED             = 10
    TAKE_OFF           = 20
    WAIT_AT_DOCK       = 30
    GO_TO_PICKUP       = 40
    WAIT_AT_PICKUP     = 50
    PICKUP             = 60
    GO_TO_DROP_OFF     = 70
    WAIT_AT_DROP_OFF   = 80
    DROP_OFF           = 90
    GO_TO_DOCK         = 100
    DOCK_LANDING       = 110
    REROUTE_PENDING    = 200
    GC_COMM_FAILURE    = 210
    ROS_COMM_FAILURE   = 220
    EMERGENCY_LANDING  = 230

class JobStatus(Enum):
    """
    High-level job status used to make decisions in Drone Manager and exposed 
    to Fleet Manager.
    """
    READY               = 0
    ASSIGNMENT_PENDING  = 1
    PICKUP_PENDING      = 2
    DELIVERY_PENDING    = 3
    RETURN_PENDING      = 4
    NOT_READY           = 99

class FleetManagerCmdType(Enum):
    """
    Used in Fleet Manager command queue to specify command type. The command 
    type is the highest level of information categorizing a command queue element.
    """
    PAUSE = 1
    GROUND = 3
    KILL = 4
    DRONE_MSG = 5
    JOB = 6
    TIMEOUT_EXCEEDED = 7

class FleetManagerDroneStatus(object):
    """
    Used in fleet manager to store high-level information about drones, targeted 
    towards what is needed to delegate jobs. This is different from 
    'DroneStatus' maintained by the drone managers.
    """
    def __init__(self,\
                job_status = None,\
                payload_id = None,\
                battery_percentage = None,\
                last_contact = None,\
                grounded = None):
        self.job_status = job_status
        self.payload_id = payload_id
        self.battery_percentage = battery_percentage
        self.last_contact = last_contact
        self.grounded = grounded

    def to_dict(self):
        return self.__dict__

class DroneManagerCmdType(Enum):
    """
    Used in Drone Manager command queue to specify command type. The command 
    type is the highest level of information categorizing a command queue element.
    """
    START = 0
    PAUSE = 1
    RESUME = 2
    ABORT = 3
    KILL = 4
    DRONE_MSG = 5
    JOB = 6

class DroneMsgType(Enum):
    """
    Used in Drone Manager when constructing a DroneMgrMsgCmd to specify message 
    type
    """
    MSG_FAILED = -1
    SET_SM_STATE = 0
    GET_SM_DATA = 1
    HB = 5
    STATE_NOTIF = 100
    OBSTRUCTION = 101

class CmdQueueElement(object):
    """
    Base type for elements in command queues used in fleet manager and drone 
    managers. The enum type of cmd_type differs between these two uses.
    """
    def __init__(self,cmd_type):
        self.cmd_type = cmd_type

class FleetMgrKillCmd(CmdQueueElement):
    def __init__(self,drone_ids=None):
        CmdQueueElement.__init__(self,FleetManagerCmdType.KILL)
        self.drone_ids = drone_ids

class FleetMgrGroundCmd(CmdQueueElement):
    def __init__(self,drone_ids=None):
        CmdQueueElement.__init__(self,FleetManagerCmdType.GROUND)
        self.drone_ids = drone_ids

class FleetMgrTimeoutCmd(CmdQueueElement):
    def __init__(self,drone_id):
        CmdQueueElement.__init__(self,FleetManagerCmdType.TIMEOUT_EXCEEDED)
        self.drone_id = drone_id


class DroneMgrMsgCmd(CmdQueueElement):
    """
    For use in Drone Manager. Encapsulates information for a message via ROS 
    service, either asynchronous from drone or in response to drone manager.
    """
    def __init__(self ,msg_type, req_data, res_data, succeeded):
        CmdQueueElement.__init__(self,DroneManagerCmdType.DRONE_MSG)
        self.msg_type = msg_type
        self.req_data = req_data
        self.res_data = res_data
        self.succeeded = succeeded #Indicates timeout.


class DroneMgrJobCmd(CmdQueueElement):
    """
    For use in Drone Manager. Encapsulates information for a newly issued 
    assigned job
    """
    def __init__(self,job):
        CmdQueueElement.__init__(self,DroneManagerCmdType.JOB)
        self.job=job

